<template>
  <div class="weights" v-if="risks.length">
    <div class="weights-wrapper">
      <div class="risk-table-wrapper">
        <table class="risk-table">
          <thead>
            <tr>
              <th></th>
              <th>Наименование поля</th>
              <th>Учитывать вес</th>
              <th>Вес поля</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(risk, index) in risks" :key="risk.uuid" :ref="risk.fieldTitleLabel">
              <td>
                <span
                  class="color"
                  :style="`background-color: ${tempColors[index]}`"
                />
              </td>
              <td>
                {{risk.fieldTitleLabel}}
              </td>
              <td>
                <ObSwitcherCheckbox v-model="risk.isActive"/>
              </td>
              <td>
                <ObInput v-model.number="risk.weight" :disabled="!risk.isActive"/>
                <div class="extend" v-if="extendNum && risk.isActive" @click="onExtend(risk)">
                  Максимально<br/>увеличить
                  <span>+{{ extendNum }}</span>
                </div>
              </td>
            </tr>
          </tbody>
        </table>
        <div class="risk-table-info">
          <p @click="spreadIncluded">
            Распределить включённые поровну
            <ObTooltip
              content="Распределить включённые поровну"
            >
              <i class="icon blue question" style="font-size: 12px" />
            </ObTooltip>
          </p>
          <div class="weights-label-total">
            <span>Cумма</span>
            {{ this.totalWeight.toFixed(3) }}
          </div>
          <div class="weights-label-error" v-if="totalWeight < 1">
            <i class="icon alert info" style="font-size: 24px"></i>
            Добавьте вес полям, чтобы&nbsp;в&nbsp;сумме получилась единица
          </div>
        </div>
      </div>
      <div class="weight-pie">
        <donut-chart
          :chartData="chartData"
          :isOpen="true"
          @mouseOverChart="onMouseOverChart($event)"
          @mouseLeaveChart="onmouseLeaveChart($event)"
        />
      </div>
    </div>
    <div class="footer">
      <ob-button label="Отменить" type="flat" @click="onReset"/>
      <ob-button label="Cохранить" type="primary" @click="onSave"/>
    </div>
  </div>
</template>

<script>
  import api from '@/api';
  import cloneDeep from "clone-deep"
  import ObSwitcherCheckbox from "common-components/src/obComponents/obSwitcherCheckbox"
  import ObInput from "common-components/src/obComponents/obInput"
  import ObButton from 'common-components/src/obComponents/obButton'
  import DonutChart from '../components/DonutChart'
  import ObTooltip from "common-components/src/obComponents/obTooltip"

  export default {
    name: "weightsTab",

    components: {
      ObSwitcherCheckbox,
      ObInput,
      ObButton,
      DonutChart,
      ObTooltip
    },

    data() {
      return {
        backup: [],
        tempColors: ['#F4F4F5', '#D1D2D6', '#A4A5AD', '#A3A5AD', '#737682', '#474B5B'],
        risks: [
          {
            fieldTitleLabel: 'participant_field__inn',
            fieldUuid: '4699c2fb-66a5-470b-a409-8d78fe36fc61',
            isActive: true,
            uuid: '4ee9b7e6-f3e5-11e9-81b4-2a2ae2dbcce4',
            weight: 0.7,
            color: "#F4F4F5"
          },
          {
            fieldTitleLabel: 'participant_field__2',
            fieldUuid: '4699c2fb-66a5-470b-a409-8d78fe36fc61',
            isActive: true,
            uuid: '4ee9b7e6-f3e5-11e9-81b4-2a2ae2dbcce5',
            weight: 0.1,
            color: "#D1D2D6"
          },
          {
            fieldTitleLabel: 'participant_field__3',
            fieldUuid: '4699c2fb-66a5-470b-a409-8d78fe36fc91',
            isActive: true,
            uuid: '4ee9b7e6-f3e5-11e9-81b4-2a2ae2dbcce3',
            weight: 0.2,
            color: "#A4A5AD"
          }
        ]
      }
    },

    created() {
      api.risks.getWeights()
        .then(({ data }) => {
          if (data.ParticipantFieldAssessmentWeightsList.length) {
            this.risks = data.ParticipantFieldAssessmentWeightsList
          }
          this.backup = cloneDeep(this.risks)
        }).catch((e) => {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      })
    },

    computed: {
      totalWeight() {
        if (this.risks.length) {
          const active = this.risks.filter(item => item.isActive)
          const weights = active.reduce((acc, item) => {
            return acc + (item.weight * 1)
          }, 0)
          return weights
        }
        return 0
      },

      chartData() {
        const active = this.risks.filter(item => item.isActive)
        return active.map((item) => ({label: item.fieldTitleLabel, weight: item.weight, color: item.color}))
      },

      extendNum() {
        return this.totalWeight < 1 ? (1 - this.totalWeight).toFixed(2) : null
      }
    },

    methods: {
      spreadIncluded() {
        const included = this.risks.filter(item => item.isActive)
        const delta = (1 / included.length).toFixed(3)
        this.risks.forEach(element => {
          if (element.isActive) {
            element.weight = delta * 1
          }
        });
      },

      onExtend(risk) {
        risk.weight = 1 * risk.weight + 1 * this.extendNum
      },

      onMouseOverChart($event) {
        this.$refs[$event.label][0].classList.add('active')
      },

      onmouseLeaveChart($event) {
        this.$refs[$event.label][0].classList.remove('active')
      },

      onReset() {
        this.risks = cloneDeep(this.backup)
      },

      onSave() {
        
      }

    }
  }
</script>

<style lang="scss">

  .simple-input {
    width: 85px !important;
    margin-right: 5px;
  }
</style>

<style lang="scss" scoped>

.weights-wrapper {
    display: flex;
    justify-content: space-between;
  }

  .risk-table-wrapper {
    position: relative;
    flex-grow: 1;
    padding-right: 100px;
  }

.risk-table {

  th {

    &:nth-child(3) {
      text-align: center;
    }

    &:last-child {
      width: 130px;
      padding-left: 40px;
    }
  }

  tr {
    &:hover > td:last-child > .extend {
        display: flex;
      }
  }

  td {

    position: relative;

    &:first-child {
      padding-left: 20px;
      width: 50px;
    }

    &:nth-child(3) {
      text-align: center;
    }

    &:last-child {
      width: 130px;
      padding-left: 40px;
    }

    input[type="text"] {
      width: 85px;
    }
  }
}

.weights-header,
 .weights-item {
  display: flex;

  span:first-child {
    flex-grow: 1;
  }

  span:nth-child(2) {
    min-width: 90px;
    margin-right: 40px;
    white-space: nowrap;
    text-align: center;
  }

  span:last-child {
    width: 85px;
  }
}

.color {
  display: inline-block;
  width: 18px;
  height: 18px;
  border-radius: 50%;
  background-color: $color-white-lilac;
}

.risk-table-info {
  position: relative;
  display: flex;
  flex-direction: column;
  align-items: flex-end;
  color: $color-blue-navy-blue;

  p {
    margin-top: 20px;
    margin-bottom: 13px;
    display: flex;
    font-size: 12px;
    line-height: 12px;
    cursor: pointer;
  }

  .icon {
    display: inline-block;
    margin-left: 7px;
    vertical-align: middle;
  }
}

.weights-label-total {
  width: 85px;
  height: 52px;
  display: flex;
  flex-direction: column;
  padding: 8px 12px;
  background-color: $color-white-lilac;
  color: $color-text-base;
  border-radius: 3px;

  span {
    margin-bottom: 4px;
    font-size: 12px;
    color: $gray-slate;
  }
}

.weights-label-error {
  width: 241px;
  height: 52px;
  padding-left: 18px;
  position: absolute;
  left: 100%;
  bottom: 0;
  display: flex;
  align-items: center;
  font-size: 12px;
  line-height: 1.3;
  color: $color-grey-span;

  .icon {
    margin-right: 13px;
    color: $color-error;
  }
}

.extend {
  display: none;
  height: 100%;
  position: absolute;
  left: 100%;
  top: 0;
  flex-direction: column;
  justify-content: center;
  padding-left: 14px;
  font-size: 12px;
  color: $color-blue-navy-blue;
  z-index: 2;
  cursor: pointer;

  span {
    color: $gray-slate;
  }
}
</style>
